unit u_sockhdr;

interface

type
  WordArray = ^TWordArray;
  TWordArray = array [0..0] of Word;

  PIPhdr = ^TIPhdr;
  TIPhdr = packed record
    ip_verlen: Byte;
    ip_tos: Byte;
    ip_len: Word;
    ip_id: Word;
    ip_off: Word;
    ip_ttl: Byte;
    ip_p: Byte;
    ip_sum: Word;
    ip_src: Cardinal;
    ip_dst: Cardinal;
  end;

  PUDPHdr = ^TUDPHdr;
  TUDPHdr = packed record
    udp_sport: Word;
    udp_dport: Word;
    udp_ulen: Word;
    udp_sum: Word;
  end;

  Ppseudohdr_udp = ^Tpseudohdr_udp;
  Tpseudohdr_udp = packed record
    saddr: Cardinal;
    daddr: Cardinal;
    zero: Byte;
    protocol: Byte;
    length: Word;
    udphdr: TUDPhdr;
  end;

  function CheckSum(Data: WordArray; Size: integer): Word;

implementation

function CheckSum(Data: WordArray; Size: integer): Word;
var
  i, Sum: integer;
  Answer: Word;
begin
  Sum := 0;
  i := 0;
  while (Size > 1) do begin
    Sum := Sum + Data^[i];
    Dec(Size, 2);
    Inc(i);
  end;
  if (Size <> 0) then Sum := Sum + Data^[i];
  Sum := (Sum shr 16) + (Sum and $ffff);
  Sum := Sum + (Sum shr 16);
  Answer := not Sum;
  Result := Answer;
end;

end.
 